SystemOrganization addCategory: #tp1!
SystemOrganization addCategory: #Tp1!

Trait named: #FojaAcademica
	uses: {}
	category: 'Tp1'!

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:23'!
cantidadDeAbandonadas

	^ (self filtrarAuscentes: (self obtenerNotas)) size.! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:23'!
cantidadDeAprobadas

	^ (self filtrarAprobados: (self obtenerNotas)) size.! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:35'!
cuantasNotasCon: unaNota


	^(self obtenerNotas select: [ :cadaNota | cadaNota = unaNota ]) size.! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 23:36'!
cuantasNotasMayorOIgual: unaNota


	^(self obtenerNotas select: [ :cadaNota | cadaNota >= unaNota ]) size.! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:24'!
filtrarAbandono: unaColeccion

	^ (unaColeccion select: [ :unElem | unElem = -1 ]).
	! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:23'!
filtrarAprobados: unaColeccion

	^ (unaColeccion select: [ :unElem | unElem > 3 ]).
	! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:26'!
filtrarDesaprobados: unaColeccion

	^ (unaColeccion select: [ :unElem | unElem < 4 & unElem > -1 ]).
	! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:24'!
filtrarPresentes: unaColeccion

	^ (unaColeccion select: [ :unElem | unElem > -1 ]).
	! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 23:41'!
notaMasAltaNVeces: nVeces

	
	| colecciontemp |
	colecciontemp := {10. 9. 8. 7. 6. 5. 4. 3. 2. 1. 0}.


	colecciontemp do:[ :unaNota | (self cuantasNotasMayorOIgual: unaNota >= nVeces ) ifTrue: [ ^ unaNota  ] ifFalse: [unaNota  = 0 ifTrue: [^ 'No habia notas suficientes']  ] ]. ! !

!FojaAcademica methodsFor: 'requirements' stamp: 'JulianGalati 9/10/2013 21:34'!
obtenerNotas 

self requiredMethods. 

! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:31'!
porcentajeDeAprobadosSobreIniciados

	^ ((self filtrarAprobados: (self obtenerNotas) ) /  (self obtenerNotas size) )* 100! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:27'!
promedioConAplazos 

	^ (self filtrarPresentes:  (self obtenerNotas)) average.! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:28'!
promedioSinAplazos 

	^ (self filtrarAprobados:  (self obtenerNotas)) average.! !

!FojaAcademica methodsFor: 'trait' stamp: 'JulianGalati 9/10/2013 22:34'!
tablaNotas
	|colecciontemp coleccionReturn |

	colecciontemp := {0. 1. 2. 3. 4. 5. 6. 7. 8. 9. 10}.
	coleccionReturn := Dictionary  new.
	colecciontemp 	do: [ :x |  coleccionReturn at: x put: (self cuantasNotasCon: x)].
	^coleccionReturn! !

Object subclass: #Alumno
	uses: FojaAcademica
	instanceVariableNames: 'legajo nombre cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Alumno class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Alumno class methodsFor: 'constructors' stamp: 'diegos 9/8/2013 23:16'!
new:  nombreA legajo:legajoA
	"comment stating purpose of message"
	|asd|
	
	asd:=Alumno new.
	
	asd legajo: legajoA.
	asd nombre: nombreA.
	asd cursos: Bag new.
	
^asd.! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
cursos
	^ cursos! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
cursos: anObject
	cursos := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
legajo
	^ legajo! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
legajo: anObject
	legajo := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
nombre
	^ nombre! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
nombre: anObject
	nombre := anObject! !

!Alumno methodsFor: 'dominio' stamp: 'macha 9/10/2013 15:13'!
obtenerNotas
	"comment stating purpose of message"
	
	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	cursos do:[:unCurso | listaDeNotas add: (unCurso alumnos at: self nombre)  ].
	^listaDeNotas.
	! !

Object subclass: #Carrera
	uses: FojaAcademica
	instanceVariableNames: 'nombreCarrera materias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Carrera class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Carrera class methodsFor: 'constructor' stamp: 'Anonymous 9/8/2013 22:58'!
new: nombreCarreraParam
	"comment stating purpose of message"
	|asd|

	asd:=Carrera new.
	asd nombreCarrera: nombreCarreraParam.
	asd alumnos: Dictionary new.
	^asd.! !

!Carrera methodsFor: 'accessing' stamp: 'Anonymous 9/8/2013 22:59'!
alumnos
	^ alumnos! !

!Carrera methodsFor: 'accessing' stamp: 'Anonymous 9/8/2013 22:59'!
alumnos: anObject
	alumnos := anObject! !

!Carrera methodsFor: 'accessing' stamp: 'diegos 9/8/2013 23:30'!
cursos
	^ cursos! !

!Carrera methodsFor: 'accessing' stamp: 'diegos 9/8/2013 23:30'!
cursos: anObject
	cursos := anObject! !

!Carrera methodsFor: 'accessing' stamp: 'diegos 9/8/2013 23:30'!
nombreCarrera
	^ nombreCarrera! !

!Carrera methodsFor: 'accessing' stamp: 'diegos 9/8/2013 23:30'!
nombreCarrera: anObject
	nombreCarrera := anObject! !

!Carrera methodsFor: 'dominio' stamp: 'JulianGalati 9/11/2013 00:47'!
obtenerNotas

	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	
	materias do: [ :unaMateria | listaDeNotas := (unaMateria  obtenerNotas , listaDeNotas)].
	
	^ listaDeNotas.! !

!Carrera methodsFor: 'testing' stamp: 'macha 9/8/2013 23:25'!
testInicializar
	"comment stating purpose of message"

	| listaAlumnos |
	
	cursos := OrderedCollection  new.
	cursos add: (Curso new:'Paradigmas').
	cursos add: (Curso new:'TADP').
	alumnos at:'macha' put:(Alumno new:'macha' legajo:1378259).
	alumnos at:'diego' put:(Alumno new:'diego' legajo:1378253).
	alumnos at:'julian' put:(Alumno new:'julian' legajo:1378255).
	alumnos at:'pedro`' put:(Alumno new:'pedro' legajo:1378251).

	cursos do:[:unCurso | unCurso testInicializar. unCurso alumnosRef: ((unCurso alumnosRef)  union: alumnos) . alumnos do: [:unAlumno |   (unAlumno cursos) add: unCurso ]].! !

Object subclass: #Curso
	uses: FojaAcademica
	instanceVariableNames: 'docentes alumnos anio alumnosRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Curso class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Curso class methodsFor: 'constructor' stamp: 'Anonymous 9/8/2013 21:57'!
new: nombreM
	"comment stating purpose of message"
	|asd|
	asd:=Curso new.
	asd nombreMateria: nombreM.
	
^asd.! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
alumnos
	^ alumnos! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
alumnos: anObject
	alumnos := anObject! !

!Curso methodsFor: 'accessing' stamp: 'diegos 9/8/2013 23:13'!
alumnosRef
	^ alumnosRef! !

!Curso methodsFor: 'accessing' stamp: 'diegos 9/8/2013 23:13'!
alumnosRef: anObject
	alumnosRef := anObject! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
anio
	^ anio! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
anio: anObject
	anio := anObject! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
docentes
	^ docentes! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
docentes: anObject
	docentes := anObject! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
nombreMateria
	^ nombreMateria! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
nombreMateria: anObject
	nombreMateria := anObject! !

!Curso methodsFor: 'dominio' stamp: 'macha 9/10/2013 15:14'!
obtenerNotas
	
	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	alumnos do:[:unaNota | listaDeNotas add: unaNota ].
	^listaDeNotas.
	! !

!Curso methodsFor: 'testing' stamp: 'macha 9/8/2013 23:26'!
testInicializar
	alumnos:= Dictionary new.
	alumnosRef:= OrderedCollection new.
	
	alumnos at: 'macha' put: 5.
	alumnos at: 'diego' put: 8. 
	alumnos at: 'julian' put: 2. 
	alumnos at: 'pedro' put: -1. 
! !

Object subclass: #Docente
	uses: FojaAcademica
	instanceVariableNames: 'cursos nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Docente class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Docente methodsFor: 'dominio' stamp: 'JulianGalati 9/11/2013 00:44'!
obtenerNotas
	"comment stating purpose of message"
	
	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	cursos do:[:unCurso | listaDeNotas := listaDeNotas , unCurso obtenerNotas ].
	^listaDeNotas.
	! !

Object subclass: #Materia
	uses: FojaAcademica
	instanceVariableNames: 'cursos nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Materia class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Materia methodsFor: 'dominio' stamp: 'JulianGalati 9/11/2013 00:48'!
obtenerNotas

	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	
	cursos do: [ :unCurso | listaDeNotas := (unCurso  obtenerNotas , listaDeNotas)].
	
	^ listaDeNotas.! !
